//
//  iregister.h
//  practical 0
//
//  Created by Mohammadreza Mousavi [mohmou] on 9/5/14.
//  Copyright (c) 2014 by Mohammadreza Mousavi [mohmou]. All rights reserved.

#ifndef lab0_iregister_h
#define lab0_iregister_h


/*
For each function write in comments:

pre-condition: what should the input paramters represent / satisfy
post-condition: what will hold after calling the function
properties: specify at least some properties that the function should satisfy; see the remainder for concrete examples
test-cases: write at least 6 test-cases representing different combination of allowed / forbidden inputs and their ouputs; at least one of the test-cases should be an instance of the specified properties

*/


/*
 iRegister:
 
 An iRegister is a structure which represents an 32-bit register and
 is equipped with standard operations to modify and display them.
 
 Complete the functions
    
 
    void setBit(int i, iRegsiter * x)
 
    void assignNipple1(int i, iRegsiter * x)
 
    void assignNipple2(int i, iRegsiter * x)
 
 
    int getBit(int i, iRegister * x);
 
    void getNipple1(int i, iRegsiter * x)
 
    void getNipple2(int i, iRegsiter * x)
 
 
    void setAll(iRegister * x);
 
    void resetAll(iRegister * x);
 
    char * reg2str(iRegister x)
 
 
    to do the following:

    setBit: sets the i'th bit of the iRegister (to 1),

    assignNipple1: sets the first four bits of iRegsiter to be the first four bits of i

    assignNipple2: sets the second four bits of iRegsiter to be the first four bits of i

 
 
    getBit: returns the i'th bit of the iRegister as an integer (1 if it is set, or 0 otherwise)
 
    setAll: sets all the bits of the iRegister (to 1),
 
    resetAll: resets all the bits of the iRegister (to 0),
 
 reg2str: returns a pointer to an array of 32 characters, with each character representing the corresponding bit of the iRegister, i.e., if the bit is set, then the character is "1" (ASCII char with code 49), or otherwise is "0" (ASCII char with code 48)
 
 */





typedef struct{
    int content;
} iRegister;



/* 
 
 void resetBit(i, iRegister *)
 
 pre-condition: i < 32 and iRegister != Null 
 
 post-condition: after reseti(i, x) the i'th bit of iRegister is 0, all other bits remain unchanged
 properties: 
 
    after resetBit(i, x),  getBit(i, x) = 0
 
    if getBit(i, x) == 0
        then getBit(j, x) reutrns the same value for all j <= 32 before and after resetBit(i, x)

 
 test-cases: 
    1,2,3. Allocate memory to an iRegister x
    first do resetAll(&x), 
    then set the i'th bit of &x by setBit(i, &x) for i = 0, 15 and 23 and then
    display the result after each and every call by 
       printf("%s",reg2str(x))
 
 
 */


void resetBit(int, iRegister *);
void setBit(int, iRegister *);

int getBit(int, iRegister *);

void setAll(iRegister *);
void resetAll(iRegister *);

void assignNipple1(int, iRegsiter *);
void assignNipple2(int, iRegsiter *);
void getNipple1(int, iRegsiter *);
void getNipple2(int, iRegsiter *);


char * reg2str(iRegister);


#endif
